/*
 * extractJobIds.hpp
 *
 *  Created on: Aug 31, 2012
 *      Author: heber
 */

#ifndef EXTRACTJOBIDS_HPP_
#define EXTRACTJOBIDS_HPP_


// include config.h
#ifdef HAVE_CONFIG_H
#include <config.h>
#endif

#include <algorithm>
#include <map>
#include <vector>

#include <boost/bind.hpp>
#include <boost/lambda/lambda.hpp>

#include "JobMarket/types.hpp"

template <typename T>
std::vector<JobId_t> extractJobIds(const std::map<JobId_t, T> &iddata)
{
  // create a vector of all job ids
  std::vector<JobId_t> jobids;
  std::transform(iddata.begin(),iddata.end(),
      std::back_inserter(jobids),
      boost::bind(&std::map<JobId_t,T>::value_type::first, boost::lambda::_1 )
  );
  return jobids;
}


#endif /* EXTRACTJOBIDS_HPP_ */
